//retrieve default LANGUAGE
if ~exists('LANGUAGE') then
  global LANGUAGE;lang=LANGUAGE;clear LANGUAGE;
else
  lang=LANGUAGE;
end

if lang<>'eng' & lang<>'fr' then
 printf("language %s is not supported, switch to ''eng''\n",lang);
 lang='eng'
end
///////////////////////////
//Define MODNUM directories
///////////////////////////

//man path
man_path  = MODNUM+'/man/';
//data_path = man_path+'data/'+lang+'/';
data_path = man_path+'data/';
//xml_path  = man_path+'xml/'+lang+'/';
xml_path  = man_path+'xml/';
//tex_path  = man_path+'tex/'+lang+'/';
tex_path  = man_path+'tex/';
bib_path  = man_path+'tex/bib/'; //(!!??!)
//html_path = man_path+'htm/'+lang+'/';
html_path = man_path+'htm/';
//pdf_path  = man_path+'pdf/'+lang+'/';
pdf_path  = man_path+'pdf/';
sbeq_path = man_path+'sblock_equiv/';
web_path  = man_path+'web/';


//
pal_path  = MODNUM+'/macros/scicos_blocks/';
simu_path = MODNUM+'/simu/';
//spec_desc_path=MODNUM+'/man/spec_desc/'; 
//PAS NECESSAIRE->c'est aussi bien dans tex_path... pour l'instant
rout_path = MODNUM+'/routines/scicos/';
mac_path  = MODNUM+'/macros';
low_rout_path=MODNUM+'/routines/mod_num_lib/';
scs_diagr_path=MODNUM+'/scs_diagr/';

//return master list of files and directories
if ~exists('tt_ml') then
 tt_ml=return_master_list(MODNUM);
end

//Define diagram list
//diagr_cs=[];
diagr_cs=[scs_diagr_path+'dyna/lorentz/','lorentz'
          scs_diagr_path+'dyna/van_der_pol/','van_der_pol_trap'
          scs_diagr_path+'dyna/van_der_pol/','van_der_pol_forc_euler'
          scs_diagr_path+'dyna/duf_van_der_pol/','duf_van_der_pol'
          scs_diagr_path+'dyna/rossler/','rossler'
          scs_diagr_path+'dyna/duffing/','duffing'
          scs_diagr_path+'dyna/chua/','chua'
          scs_diagr_path+'dyna/chua/','chua_sub'
          scs_diagr_path+'dyna/chua/','chua_masque'];
//diagr_ds=[];
diagr_ds=[scs_diagr_path+'dyna/logistique/','logistique_bif_2D'
          scs_diagr_path+'dyna/logistique/','logistique_bif_3D'
          scs_diagr_path+'dyna/henon/','henon'
          scs_diagr_path+'dyna/sig_delta/','sig_delta_1st_order'
          scs_diagr_path+'dyna/frey/','frey'
          scs_diagr_path+'dyna/lin_chua/','lin_chua'
          scs_diagr_path+'dyna/lin_chua/','lin_chua_cod_decod'];
//diagr_os=[];
diagr_os=[scs_diagr_path+'pll/vco/','scicos_vco'
          scs_diagr_path+'pll/vco/','discr_vco'];
//diagr_is=[];
diagr_is=[scs_diagr_path+'pll/synthe/','synthe_scicos';
          scs_diagr_path+'pll/synthe/','synthe_eclat';
          scs_diagr_path+'pll/synthe/','synthe_int';
          scs_diagr_path+'pll/synthe/','synthe_interp';];
//diagr_fs=[];
diagr_fs=[scs_diagr_path+'pll/synthe_frac/','synthe_sd_quick'];
//diagr_PSK=[];
diagr_PSK=[scs_diagr_path+'comsys/vectorial/qpsk/','qpsk_teb';
           scs_diagr_path+'comsys/vectorial/qpsk/','qpsk_teb_int';
           scs_diagr_path+'comsys/vectorial/qpsk/','qpsk_etal_teb';
           scs_diagr_path+'comsys/sequential/qam/','qam_seq'];
//diagr_SD=[];
diagr_SD=[scs_diagr_path+'comsys/sequential/sig_delta/','mash_1er_ordre';
          scs_diagr_path+'comsys/sequential/sig_delta/','mash_2eme_ordre';
          scs_diagr_path+'comsys/sequential/sig_delta/','mash_gauss';
          scs_diagr_path+'comsys/sequential/sig_delta/','sig_delta_2';
          scs_diagr_path+'comsys/sequential/sig_delta/','sig_delta_3'];
//diagr_FSK=[];
diagr_FSK=[];
//diagr_FSK_chaos=[];
diagr_FSK_chaos=[scs_diagr_path+'pll/transchaos/','trans_chaos_em';
                 scs_diagr_path+'pll/transchaos/','trans_chaos_em_rec'];
//diagr_elec=[];
diagr_elec=[scs_diagr_path+'electrical/','atten'];

diagr_all=[diagr_cs;diagr_ds;diagr_os;
           diagr_is;diagr_fs;
           diagr_FSK;diagr_PSK;diagr_SD;diagr_FSK_chaos;
           diagr_elec];

//Define simulation script list
sim_chaos=[simu_path,'lin_chua_sim';
           simu_path,'lin_chua_teb_sim'];
sim_synthe=[simu_path,'synthe_int_sim'
            simu_path,'synthe_int_jit_sim'
            simu_path,'synthe_sd_quick_sim'];
sim_PSK=[simu_path,'mash_gauss_sim';
         simu_path,'qpsk_teb_sim';
         simu_path,'rayleigh_sim'];
sim_all=[sim_chaos;sim_synthe;sim_PSK];
//Define script list
sce_all=[MODNUM+'/','builder';
         mac_path+'/generate_doc/','load_generate_doc_function'];
//Define if simulation of script file are executed
with_sim=%t;
//Define library name for internal section
lib_build=['build_util';'find_file']; 
lib_gen_doc=['gen_doc_util';'generate_doc';'xmltotex'];
//Define excluded library 
ex_lib_name=['other';'scicos_blocks';lib_build;lib_gen_doc];
//Define interfaced functions of modnum library
mod_num_sci_lib='mod_num_sci_lib';
if ~exists('modnum_sci_func') then
 sci_func=["genint";"modpsk";"surecht"];
end
//Define name of routines library of modnum
mod_num_rout_lib='mod_num_rout_lib';
//Define latex command
latex_cmd='latex -interaction=nonstopmode ';
//Define dvips command
dvips_cmd='dvips -E ';
//Define latex2html command
latex2html_cmd='latex2html -white -info """" -no_navigation -link 0 -split 3 -short_extn -image_type gif -prefix ';
//Define bibtex command
bibtex_cmd='bibtex ';
//Define web browser
wbr_cmd='mozilla';
//Define with_gui flag
with_gui=%t;
//Define xwd command
xwd_cmd='xwd ';
//Define dir commmand
dir_cmd='ls ';
//Define mkdir command (MUST USE scilab function mkdir('')
mkdir_cmd='mkdir ';
//Define move file command
mv_cmd='mv -f ';
//Define remove file command
rm_cmd='rm -fr ';
//Define copy command
cp_cmd='cp -fr ';
//Define scilab browser flag
sci_browser=%t;
//Load file of function 
//Disable scilab function protection
prot=funcprot();
funcprot(0);
////////////////

//Build and load generate_doc library
build_lib('/macros/generate_doc','mod_num_generate_doc');
mod_num_generate_doc=lib(MODNUM+'/macros/generate_doc/');
//Build and load xml2tex library
build_lib('/macros/xmltotex','mod_num_xmltotex');
mod_num_xmltotex=lib(MODNUM+'/macros/xmltotex/');
//Build and load generate_doc_util library
build_lib('/macros/gen_doc_util','mod_num_gen_doc_util');
mod_num_gen_doc_util=lib(MODNUM+'/macros/gen_doc_util/');

//Return to original scilab function protection mode
funcprot(prot);

//increase stacksize (for scicos_simulate)
stacksize(60000000);
