/* cmplxa_c subroutine
 * complex addition computation
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* cmplxa_c routine de calcul d'addition-soustraction de vecteurs complexes
 *
 * n           : la taille des vecteurs
 * sig         : signe de l'opration
 * [z1_r;z1_i] : adresses de dpart du vecteur complexe 1
 * [z2_r;z2_i] : adresses de dpart du vecteur complexe 2
 * [y_r;y_i]   : adresses de dpart du vecteur complexe rsultat
 *
 * rmq : doit exister en version BLAS(!?)
 */
 
void cmplxa_c(int *n,int *sig,double *z1_r,double *z1_i,double *z2_r,double *z2_i,double *y_r,double *y_i)
{
 /*dclaration des variables*/
 int i;

 /*ralise multiplication complex*/
 for(i=0;i<(*n);i++)
 {
  y_r[i]=z1_r[i]+(*sig)*z2_r[i];
  y_i[i]=z1_i[i]+(*sig)*z2_i[i];
 }

 return;
}
