/* demodpsk_c subroutine
 * Phase Shift Keying demodulator
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* demodpsk_c routine de calcul de dmodulation PSK
 *
 * Entres :
 * n      : taille des vecteur originaux
 * m      : nombre d'tats (scalaire)
 * i_c    : vecteur de la composante I
 * q_c    : vecteur de la composante Q
 * Sorties :
 * y      : vecteur du numro symbole
 * 
 * dpendance :
 * math.h
 */
 
void demodpsk_c(int *n,int *m,double *i_c,double *i_q,double*y)
{
 /*Dclaration des variables*/
 int i;
 double phi;
 
 for(i=0;i<(*n);i++)
 {
  /*Calcul de la phase*/
  phi=atan2(-i_q[i],i_c[i]);
  if(phi<0) phi = phi + 2*M_PI;
  /*Calcul du numro symbole*/
  y[i]=(int)(phi*(*m)/(2*M_PI));
 }
 return;
}
