/* demodqam_c subroutine
 * Quadrature Amplitude Modulation demodulator
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* demodqam_c routine de calcul d'un dmodulataur mQAM
 *
 * Entres :
 * n :longueur des vecteurs d'entres
 * m :longueurs des mots binaires en nombre de bits (scalaire)
 * i_c :adresse de dpart du vecteur de la composante I
 * q_c :adresse de dpart du vecteur de la composante Q
 *
 * Sortie :
 * y : adresse de dpart du vecteur du symbole
 *
 * Dpendances:
 */
void demodqam_c(int *n,int *m,double *i_c,double *q_c,double *y)
{
 /*dclaration des variables*/
 int i,j;
 int ng,nd;
 int d,g;
 
 for(i=0;i<(*n);i++)
 {
  /*Calcul des slecteurs binaires (c'est maladroit!!)*/
  nd=(1<<(*m)/2)-1;
  ng=(1<<(*m))-1-nd;

  /*rcupration des valeurs d'entre*/
  d=(int)i_c[i];
  g=(int)q_c[i];

  /*Calcul les nombres binaires droit et gauche*/
  d=(d+nd)/2;
  g=((g+nd)/2)<<((*m)/2);

  /*Calcul du registre de sortie y[]*/
  y[i]=d+g;
 }
 return;
}
