/* nfilter_c subroutine
 * FIR computation
 * with classic discrete convolution method
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* nfilter_c : routine de calcul d'un filtre  rponse impulsionnelle fini 
 *             par convolution numrique
 *
 * Entres :
 * n : longueur du vecteur d'entre  filtrer
 * nbcoef : longueur de la rponse impulsionelle
 * u : adresse de dpart du vecteur d'entre  filtrer
 * pulse : adresse de dpart de la rponse impulsionelle
 *
 * Sorties :
 * y : adresse de dpart du vecteur filtr
 * 
 * Entres/sorties :
 * z : adresse de dpart du vecteur mmoire du filtre
 */
 
void nfilter_c(int *n,int *nbcoef,double *u,double *pulse,double *y,double *z)
{
 /*dclaration*/
 double somme;
 int i,j;
 
 for(j=0;j<(*n);j++)
 {
  /*calcul sortie*/
  somme=0;
  for(i=0;i<(*nbcoef)-1;i++)
  {
   somme=somme+z[(*nbcoef)-1-i]*pulse[i];
  }
  somme=somme+u[j]*pulse[*nbcoef-1];
  
  /*calcul mmoire*/
  for(i=0;i<(*nbcoef)-1;i++)
  {
   z[(*nbcoef)-i-1]=z[(*nbcoef)-i-2];
  }
  z[0]=u[j];
  
  /*recopie sortie dans y*/
  y[j]=somme;
 }
 
 return;
}
