/* sousecht_c subroutine
 * Down-Sampling Computation
 * IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "mod_num_lib.h"

/* sousech_c routine de calcul de sous-chantillonnage en temporel
 *
 * Entres :
 * n      : taille du vecteur original
 * nech   : facteur de sous-chantillonnage
 * init_c : valeur initiale du compteur 
 * u      : vecteur d'entre  sous-chantillonner
 * Sorties :
 * y      : vecteur de sortie
 *
 */
 
void sousecht_c(int *n,int *nech,int *init_c,double *u,double*y)
{
 /*Dclaration des variables compteurs*/
 int i,j;
 int count; 
 
 /*Rcupre valeur initiale du compteur*/
 count=*init_c;
 /*raz j*/
 j=0;

 /*Pour tous les chantillons du vecteur d'entre*/
 for(i=0;i<(*n);i++)
 {
  /*if(i==(count-1))*/
  if(i==count)
  {
   y[j]=u[i];
   count += (*nech);
   j++;
  }
 }
 return;
}
