/* chuafonc Scicos Chua non-linear function block
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 8 novembre 2003 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#define Abs(x) ( ( (x) >= 0) ? (x) : -( x) )
#include "machine.h"

/* Cette fonction de simulation ralise la fonction non linaire de la diode de Chua :
 *
 * y=m1*u+1/2*(m0-m1)*(abs(u+E)-abs(u-E))
 *
 * o m0 et m1 sont des vecteurs de paramtres rels,
 * E=1 et u est le vecteurs des entres, y le vecteur des sorties
 *
 * Entre rgulire : u[0..nu-1] : vecteur des entres
 * Sortie rgulire : y[0..nu-1] : vecteur des sorties
 * Entre vnementielle : nant (hritage)
 * sortie vnementielle : nant
 * paramtres : rpar[0..nu-1] vecteur m0
 *              rpar[nu..2*nu-1] vecteur m1
 */
 
/*prototype*/
void
chuafonc(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
             ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
    /*dclaration des variables*/
    double *y;
    double *u;
    int nu,i;

    /*rcupration des adresses des ports rguliers*/
    y=(double *)outptr[0];
    u=(double *)inptr[0];

    /*rcupration de la taille du port d'entre u*/
    nu = insz[0];

    /*Calcule du registre de sortie*/
    for(i=0;i<nu;i++)
        y[i]=rpar[nu+i]*u[i]+0.5*(rpar[i]-rpar[nu+i])*(Abs(u[i]+1)-Abs(u[i]-1));
}
