/* convsp Scicos Convertisseur srie parralle
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7&3.0
 * 21 dcembre 2003 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "machine.h"

/* Cette fonction ralise la conversion "srie-parallle". Le valeur du vecteur d'entre
 * U[] est stocke dans Z[] et est dlivre lorsque le nombre d'chantillons stock est N,
 * avec N la taille du port de sortie.
 *
 * entres rgulires : u[0] : valeur d'entre
 * sorties rgulires : y[0..N-1] : vecteur de sortie
 * tats discrets : z[0..N-1] : valeur u[k-N,..,k-2,k-1,k]
 *                 z[N] : compteur chantillons
 */
 
/*prototype*/
void convsp(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
            ipar,nipar,inptr,insz,nin,outptr,outsz,nout)

int *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  int ny,k;

  /*Rcupration des adresses de ports rguliers*/
  y=(double *)outptr[0];
  u=(double *)inptr[0];

  /*rcupration de la taille du port de sortie*/
  ny=outsz[0];

  /*Uniquement sur le flag 1*/
  if(*flag==1)
  {
   /*Test valeur compteur chantillons*/
   if((int)z[ny]==outsz[0])
   {
    /*RAZ compteur chantillons*/
    z[ny]=0;
    /*Recopie z dans y*/
    F2C(dcopy)(&ny,&z[0],(k=1,&k),&y[0],(k=1,&k));
    /*Ajout du nouveau point*/
    z[0]=u[0];
    /*Incremente compteur chantillon*/
    z[ny]++;
   }
   else
   {
    /*ajout du nouveau point*/
    z[(int)z[ny]]=u[0];
    /*Incremente compteur chantillon*/
    z[ny]++;
   }
  }
}
