/* imodulob Scicos integer modulob function block
 * Type 2 simulation function - scilab-2.6&2.7&3.0
 * IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"
#include <stdio.h>

/* Cette fonction de simulation propose de raliser la fonction
 * modulo rencontre dans les systmes numriques traitant les oprations
 * sur entier en code complment  2.
 * entres rgulires : u[0..nu-1]
 * sorties rgulires : y[0..nu-1] = mod[u[0..nu-1]]
 * paramtres entiers : ipar[0..nu-1] : nombre de bits des mots entiers.
 *
 * Rmq : l'entre de type double est tronque  sa valeur entire.
 *           la sortie est tjs positive
 */

/*Prototype*/
void imodulob(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
              ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
    /*Dclaration des variables*/
    int i,nu;
    double *y;
    double *u;
    long ent; /*Dclaration d'un entier de type long long int*/

    /*Rcupration des adresses des ports rguliers*/
    y=(double *)outptr[0];
    u=(double *)inptr[0];

    /*Rcupration de la taille du port d'entre*/
    nu=insz[0];

    for(i=0;i<nu;i++)
    {
     /*Rcupration de la valeur d'entre*/
     ent = (long) u[i];

     /*Conversion en nombre entier non sign*/
     ent &= (2<<(ipar[i]-1)) - 1;

     /*Place nombre converti dans le registre de sortie*/
     y[i] = ent;
    }
}
