/* inserzerovec Scicos vectorial zero instertion
 * Type 4 simulation function ver 1.0 - scilab-2.6&2.7
 * 4 janvier 2005 - IRCOM GROUP - Author : A.Layec
 */
 
/* REVISION HISTORY :
 * $Log$
 */
 
#include "machine.h"
#include "scicos_block.h"

/* Cette fonction transforme un vecteur de taille Nu en un vecteur
 * de taile Ny, avec Ny>Nu, et en ajoutant des zros dans l'espace > Nu
 *
 * Entre rgulire  : u[0..nu-1] : vecteur d'entre de taille nu
 * sorties rgulire : y[0..ny-1] : vecteur de sortie de taille ny
 */

/*prototype*/
void inserzerovec(scicos_block *block,int flag)
{
  /*Dclaration des variables*/
  double *y;
  double *u;
  int i,nu,ny,k;

  /*Rcupration des adresses des ports rguliers*/
  y=(double *)block->outptr[0];
  u=(double *)block->inptr[0];

  /*Rcupration des tailles des ports rguliers*/
  nu=block->insz[0];
  ny=block->outsz[0];

  /*recopie u[] dans y[]*/
  F2C(dcopy)(&nu,&u[0],(k=1,&k),&y[0],(k=1,&k));

  /*ajoute les zros*/
  for(i=nu;i<ny;i++) y[i]=0;
}
